/* 
    Ming-Ching Tiew mctiew@yahoo.com
    9th March 2005 
    GPL source
    gcc lzmad.c LzmaDecode.c -o lzmad
 */
#include <stdio.h>
#include <stdlib.h>
#include "LzmaDecode.h"

int main(int argc, char** argv)
{
   FILE * fp;
   unsigned long size;
   unsigned int outsize;
   unsigned long c_byte = 0;
   unsigned char prop0;
   unsigned int dictsize;
   unsigned int zero;
   int result, lzma_workspace_size;
   char *s, *d, *dictionary, *lzma_workspace;
   int lp,lc, pb;
   fp = fopen( argv[1], "r" );
   if( fp == NULL )
   {
   	fprintf(stderr, "%s: argument 1 has to be an existing file!\n", argv[0]);
   	exit(1);
   }
   // to get the file size 
   fseek(fp, 0L, SEEK_END);
   // compressed data is file size - 13
   size = ftell(fp) - 13;
   // allocate just enough memory
   s = (char*) malloc(size); 
   // move back up   
   fseek(fp, 0L, SEEK_SET);
   // read the property value
   fread( &prop0, 1, 1, fp);
   if ( prop0 > 5*9*5 )
   {
      fprintf( stderr, "%s: invalid file format!\n");
      exit(2);
   }
   // read the dictionary size
   fread( &dictsize, 4, 1, fp);
   // read the original file size
   fread( &outsize, 4, 1, fp);
   if( outsize < size )
   {
      fprintf( stderr, "%s: invalid file size!\n");
      exit(3);
   }
   // ignore file size greater than 4 bytes
   fread( &zero, 4, 1, fp);
   if ( zero != 0 )
   {
      fprintf( stderr, "%s: invalid file or too big!\n");
      exit(4);
   }
   // read the whole file
   fread(s, size, 1, fp); 
   fclose( fp);
   d = (char*) malloc( outsize  ); 
   // calculate the properties
   for (pb = 0; prop0 >= (9 * 5); pb++, prop0 -= (9 * 5));
   for (lp = 0; prop0 >= 9; lp++, prop0 -= 9);
   lc = prop0;
   lzma_workspace_size =  (LZMA_BASE_SIZE + (LZMA_LIT_SIZE << (lc + lp))) * sizeof(CProb);
   lzma_workspace = (char*)malloc(lzma_workspace_size); 
   //
   result = LzmaDecode( lzma_workspace, lzma_workspace_size, lc, lp, pb,
      s, size, d, outsize, &outsize );
   if( result != 0 )
   {
      fprintf( stderr, "%s: decode error=%d\n", argv[0], result);
      exit(5);
   } 
   fwrite( d, outsize, 1, stdout);
   free(s); 
   free(d);
   free(lzma_workspace);
   return 0;
}
